/* sf16d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__16 = 16;

/* Subroutine */ int sf16d_c(doublereal *x, doublereal *ber, doublereal *bei,
        doublereal *aker, doublereal *akei, integer *ierr)
{
    /* Initialized data */

    static doublereal ten = 10.;
    static doublereal e2[9] = { -2.43e-8,7.5e-8,5.929e-7,1.6431e-6,-7.2e-9,
            -5.18006e-5,-7.031241e-4,-.008838834,0. };
    static doublereal sys005 = 1.570796326794897;
    static doublereal sys011 = .3926990816987242;
    static doublereal sys003 = 6.283185307179586;
    static doublereal sys001 = 3.141592653589793;
    static doublereal sys039 = .5772156649015329;
    static doublereal sys029 = .7071067811865475;
    static doublereal sys059 = 1.7e308;
    static doublereal zmax = 2040.;
    static doublereal one = 1.;
    static doublereal zero = 0.;
    static doublereal half = .5;
    static doublereal c1[9] = { 5.16070465e-5,-.0048987125727,.25977730007,
            -7.2422567278207,93.8596692971726,-470.9502795889968,
            678.1684027663091,-156.2499999995701,.9999999999974 };
    static doublereal c2[9] = { 4.4913e-6,-5.444243175e-4,.0384288282734,
            -1.4963342749742,28.9690338786499,-240.2807549442574,
            678.1684027769807,-434.0277777777479,24.9999999999998 };
    static doublereal c3[9] = { 1.54363047e-5,-.001806477786,.1222087382192,
            -4.5187459132639,81.95247716062,-623.0136717405201,
            1548.4845196730992,-795.7175925924866,24.9999999999993 };
    static doublereal c4[9] = { 1.2161109e-6,-1.797627986e-4,.0159380149705,
            -.8061529027876,21.2123451660231,-255.0971742710479,
            1153.8281852814561,-1412.8508391203636,234.375 };
    static doublereal e1[9] = { 4.92e-8,1.452e-7,1.35e-8,-1.6192e-6,
            -1.12207e-5,-5.17869e-5,7e-10,.0088388346,1. };

    /* Builtin functions */
    double log(doublereal), sin(doublereal), cos(doublereal), exp(doublereal),
             sqrt(doublereal);

    /* Local variables */
    static integer i__;
    static doublereal s, t, z__;
    extern /* Subroutine */ int utsf11_c(integer *, integer *);
    static doublereal b1, b2, b3, b4, r1, r2, z4, dc, de, ds, sm, tm, zi, dcm,
             arg, con, dsm, dsq, zim, zsq;

    *ierr = 0;
    z__ = abs(*x);
    if (z__ > ten) {
        goto L30;
    }
    if (z__ == zero) {
        goto L20;
    }
    z__ /= ten;
    zsq = z__ * z__;
    z4 = zsq * zsq;
    b1 = c1[0];
    b2 = c2[0];
    b3 = c3[0];
    b4 = c4[0];
    for (i__ = 2; i__ <= 9; ++i__) {
        b1 = b1 * z4 + c1[i__ - 1];
        b2 = b2 * z4 + c2[i__ - 1];
        b3 = b3 * z4 + c3[i__ - 1];
        b4 = b4 * z4 + c4[i__ - 1];
/* L10: */
    }
    *ber = b1;
    *bei = zsq * b2;
    if (*x < zero) {
        goto L60;
    }
    r1 = zsq * b3;
    r2 = z4 * b4;
    con = log(*x * half) + sys039;
    *akei = -sys005 * half * *ber + (r1 - *bei * con);
    *aker = sys005 * half * *bei - (r2 + *ber * con);
    goto L90;
L20:
    *ber = one;
    *bei = zero;
    *akei = -half * sys005;
    *aker = sys059;
    goto L90;
L30:
    if (z__ > zmax) {
        goto L50;
    }
    zi = ten / z__;
    zim = -zi;
    s = e1[0];
    sm = s;
    t = e2[0];
    tm = t;
    for (i__ = 2; i__ <= 9; ++i__) {
        s = s * zi + e1[i__ - 1];
        t = t * zi + e2[i__ - 1];
        sm = sm * zim + e1[i__ - 1];
        tm = tm * zim + e2[i__ - 1];
/* L40: */
    }
    arg = z__ * sys029;
    ds = sin(arg - sys011);
    dc = cos(arg - sys011);
    dsm = sin(arg + sys011);
    dcm = cos(arg + sys011);
    de = exp(arg);
    dsq = sqrt(sys003 * z__);
    *ber = de * (s * dc - t * ds) / dsq;
    *bei = de * (t * dc + s * ds) / dsq;
    if (*x < zero) {
        goto L60;
    }
    *akei = sys001 * (tm * dcm - sm * dsm) / (de * dsq);
    *aker = sys001 * (sm * dcm + tm * dsm) / (de * dsq);
    goto L90;
L50:
    *ber = zero;
    *bei = zero;
    *ierr = 66;
    if (*x < zero) {
        goto L70;
    }
    *akei = zero;
    *aker = zero;
    goto L80;
L60:
    *ierr = 1;
L70:
    *akei = sys059;
    *aker = sys059;
    if (*ierr == 0) {
        goto L90;
    }
L80:
    utsf11_c(ierr, &c__16);
L90:
    return 0;
} /* sf16d_c */
